

proc trees_cre_new_session {} {
    global session
    
        image create bitmap dirimg -background #ffff80 -data "
            #define dir_width 17
            #define dir_height 16
            static unsigned char dir_bits[] = {
               0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x01, 0x00, 0x10, 0x02, 0x00,
               0x08, 0x04, 0x00, 0xfc, 0x7f, 0x00, 0x04, 0x40, 0x00, 0x04, 0x40, 0x00,
               0x04, 0x40, 0x00, 0x04, 0x40, 0x00, 0x04, 0x40, 0x00, 0x04, 0x40, 0x00,
               0x04, 0x40, 0x00, 0xfc, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};" \
             -maskdata "
            #define dirm_width 17
            #define dirm_height 16
            static unsigned char dirm_bits[] = {
               0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x01, 0x00, 0xf0, 0x03, 0x00,
               0xf8, 0x07, 0x00, 0xfc, 0x7f, 0x00, 0xfc, 0x7f, 0x00, 0xfc, 0x7f, 0x00,
               0xfc, 0x7f, 0x00, 0xfc, 0x7f, 0x00, 0xfc, 0x7f, 0x00, 0xfc, 0x7f, 0x00,
               0xfc, 0x7f, 0x00, 0xfc, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};"

    set session(status) ACTIVE
    #trees_update_status

    dialog_create "Create New Session" .newsession

    set info [dialog_info .newsession]

    label ${info}.samplbl_l -text "Sample Label: "
    entry ${info}.samplbl_e -textvariable session(sample_label)

    label ${info}.analystname_l -text "Analyst Name: "
    entry ${info}.analystname_e -textvariable session(analyst_name)

    label ${info}.notes_l -text "Notes: "
    text ${info}.notes_t -height 4 -width 25

    label ${info}.workdir_l -text "Work Directory: "
    entry ${info}.workdir_e -textvariable session(directory)
    button ${info}.workdir_b -image dirimg \
        -command {
                    global session
                    set session(directory) [tk_getDirectory]
                }
    
    
    
    
    grid ${info}.samplbl_l -row 0 -column 0 -sticky ne
    grid ${info}.samplbl_e -row 0 -column 1 -columnspan 2 -sticky news

    grid ${info}.analystname_l -row 1 -column 0 -sticky ne
    grid ${info}.analystname_e -row 1 -column 1 -columnspan 2 -sticky news

    grid ${info}.notes_l -row 3 -column 0 -sticky ne
    grid ${info}.notes_t -row 3 -column 1 -columnspan 2 -sticky news

    grid ${info}.workdir_l -row 4 -column 0 -sticky ne
    grid ${info}.workdir_e -row 4 -column 1 -sticky news
    grid ${info}.workdir_b -row 4 -column 2 -sticky news


    


    set cntls [dialog_controls .newsession]
    
    button ${cntls}.okay -text "Okay" \
        -command {
                    global session
                    
                    set result [trees_verify_new_session]
                    if {$result} {
                        set session(status) COMPLETE
                        #trees_update_status
                        destroy .newsession
                    }
                }

    button ${cntls}.cancel -text "Cancel" \
        -command {
                    global session
                    
                    set session(status) NONE
                    #trees_update_status
                    destroy .newsession
                }
                
    grid ${cntls}.okay x ${cntls}.cancel -sticky news
    grid columnconfigure $cntls 1 -minsize 25
    
    

    set session(basename) treestest
    set session(needsave) no
    set session(start_date) [exec date "+%l:%M %p  %b %d, %Y"]
    set session(last_change_date) [exec date "+%l:%M %p  %b %d, %Y"]
}


proc trees_ver_new_session {} {
    global session
    
    if {![info exists session(directory)]} {
        messagebox "Error" "Error: No session directory has been created!"
        return 0;
    } elseif {![file isdirectory $session(directory)]} {
        messagebox "Error" "Error: The work directory is not valid!"
        return 0;
    } elseif {[glob -nocomplain $session(directory)/*] != ""} {
        messagebox "Error" "Error: The work directory has files in it.  Please choose an empty work directory when creating a new session."
        return 0;
    }

    return 1;
}



proc trees_mod_session {} {
    global session
    
    dialog_create "Modify Session" .modsession

    set info [dialog_info .modsession]

    label ${info}.samplbl_l -text "Sample Label: "
    entry ${info}.samplbl_e -textvariable session(sample_label)

    label ${info}.analystname_l -text "Analyst Name: "
    entry ${info}.analystname_e -textvariable session(analyst_name)

    label ${info}.notes_l -text "Notes: "
    text ${info}.notes_t -height 4 -width 25

    
    grid ${info}.samplbl_l -row 0 -column 0 -sticky ne
    grid ${info}.samplbl_e -row 0 -column 1 -columnspan 2 -sticky news

    grid ${info}.analystname_l -row 1 -column 0 -sticky ne
    grid ${info}.analystname_e -row 1 -column 1 -columnspan 2 -sticky news

    grid ${info}.notes_l -row 3 -column 0 -sticky ne
    grid ${info}.notes_t -row 3 -column 1 -columnspan 2 -sticky news



    set cntls [dialog_controls .modsession]
    
    button ${cntls}.okay -text "Okay" \
        -command {
                        destroy .modsession
                }
                
    grid ${cntls}.okay -sticky news
}


set trees_dir "/home/conner/trees_work/TREES_v0.0a0/library"
lappend auto_path $trees_dir
#Library_UpdateIndex $trees_dir

trees_new_session
