proc language_update {labelvar language} {
    switch -exact -- $language {
        english {
            language_update_main $labelvar $language        
            language_update_skelplot $labelvar $language        
            language_update_attributes $labelvar $language        
            #language_update_capture $labelvar $language        
            #language_update_attributes $labelvar $language        
        }
        default {
            bgerror "Language \"${language}\" is not supported!"
        }
    }
}


proc language_update_main {labelvar language} {
    upvar #0 $labelvar label

    if {$language == "english"} then {
        # Main Menus
        set label(file,title) "File"
        set label(edit,title) "Edit"
        set label(help,title) "Help"
        set label(lang,title) "Language"
        set label(skeletonplot,title) "SkeletonPlot"
	set label(stage,title) "StageMotion"
        # File Menu
        set label(menu,file,new) "New"
        set label(menu,file,open) "Open"
        set label(menu,file,close) "Close"
        set label(menu,file,save) "Save"
        set label(menu,file,saveas) "Save As..."
        set label(menu,file,csv) "Export CSV..."
        set label(menu,file,widthrwl) "Export ring width..."
        set label(menu,file,laterwl) "Export latewood width..."
        set label(menu,file,earlyrwl) "Export earlywood width..."
        set label(menu,file,exit) "Exit"
        # Edit Menu
        set label(menu,edit,modifysession) "Modify Session Info"
        set label(menu,edit,modseriesname) "Modify Sample Name"
        # Skeleton Plot Menu
        set label(menu,skeletonplot,options) "Skeleton Plot Options"
        set label(menu,skeletonplot,attributes) "Ring Boundary Attributes"
        set label(menu,skeletonplot,select) "Select Ring by Year"
        set label(menu,skeletonplot,addring) "Add Ring Boundary"
        set label(menu,skeletonplot,removering) "Remove Ring Boundary"
        set label(menu,skeletonplot,endyear) "Set End Year"
        set label(menu,skeletonplot,startyear) "Set Start Year"
        set label(menu,skeletonplot,redraw) "Redraw Skeleton Plot"
        set label(menu,skeletonplot,invert) "Invert Skeleton Plot"
        set label(menu,help,balloon) "Balloon Help On"
        set label(menu,help,about) "About"
	# Stage Motion Menu
	set label(menu,stage,link) "Link"
        # Options Menu
        set label(menu,options,noprompt) "No Prompting"
        # Debug Menu
        set label(menu,debug,title) "Debug"
        set label(menu,debug,sessionlog) "Session Log"
        set label(menu,debug,variables) "View Global Variables"
        set label(menu,debug,exitnow) "Exit Now"

        # Titles
        set label(titles,exit) "Exit"

        # Messages
        set label(message,exit) "Do you really want to exit program?"

        # Buttons
        set label(button,exityes) "Exit"
        set label(button,exitno) "Don't Exit"
        set label(button,ok) "OK"
        set label(button,cancel) "Cancel"
        set label(button,yes) "Yes"
        set label(button,no) "No"
        set label(button,apply) "Apply"
        set label(button,dismiss) "Dismiss"
        
        # Button Labels
        set label(capture,label) "Capture\nFrames"
        set label(mosaic,label) "Create\nMosaic"
        set label(rings,label) "Find\nRings"
        set label(measure,label) "Measure\nRings"
        set label(skelplot,label) "Create\nSkel. Plot"
        
        # Legend labels
        set label(legend,title) "Status Legend"
        set label(legend,active) "Active"
        set label(legend,complete) "Complete"
        set label(legend,notused) "Not Used"

        # Session Info labels
        set label(sessioninfo,title) "Session Information"
        set label(sessioninfo,label) "Sample Label: "
        set label(sessioninfo,analyst) "Analyst Name: "
        set label(sessioninfo,start) "Start Date: "
        set label(sessioninfo,change) "Last Change: "
        set label(sessioninfo,notes) "Notes: "

        set label(exit,verify) "Close current session?"
        set label(exit,save) "Save current session before closing?"
        
        set label(register,illum-title) "Flatten Field?"
        set label(register,illum-message) "Perform Flat Fielding During Registration?"
        set label(register,biasgain-title) "Bias / Gain Adjust?"
        set label(register,biasgain-message) "Perform Bias/Gain Adjustments During Registration?"

        set label(options,title) "Options"
    }
}


proc language_update_skelplot {labelvar language} {
    upvar #0 $labelvar label

    if {$language == "english"} then {
      # Menus
      set label(skelplot,file,title) "File"
      set label(skelplot,help,title) "Help"
      set label(skelplot,viewm,title) "View"
      set label(skelplot,window,title) "Window"
      set label(skelplot,sample,title) "Tree Sample"
      set label(skelplot,lang,title) "Language"

      set label(skelplot,file,load) "Load New Sample"
      set label(skelplot,file,random) "Create Random Sample"
      set label(skelplot,file,save) "Save"
      set label(skelplot,file,saveas) "Save As..."
      set label(skelplot,file,exit) "Exit"

      set label(skelplot,sample,cross) "Cross-date Samples"

      set label(skelplot,window,main) "Main"
      set label(skelplot,window,attribs) "Attributes"
      set label(skelplot,window,options) "Options"

      set label(skelplot,help,about) "About"

      set label(skelplot,cross,load) "Load Master Series"

      # Options
      set label(skelplot,misc,rings) "Number of Rings:"
      set label(skelplot,misc,abcutoff) "Absolute Value:"
      set label(skelplot,misc,diffcutoff) "First Difference:"

      set label(skelplot,mouse,title) "Mouse Action:"
      set label(skelplot,mouse,add) "Add"
      set label(skelplot,mouse,remove) "Remove"
      set label(skelplot,mouse,resize) "Resize"
      set label(skelplot,mouse,text) "Text"

      set label(skelplot,addrem,title) "New Lines:"
      set label(skelplot,addrem,norm) "Normal"
      set label(skelplot,addrem,wide) "Wide"
      set label(skelplot,addrem,false) "False"
      set label(skelplot,addrem,absent) "Absent"

      set label(skelplot,scale,title) "Graph Size:"
      set label(skelplot,scale,small) "Small"
      set label(skelplot,scale,medium) "Medium"
      set label(skelplot,scale,large) "Large"

      set label(skelplot,orient,title) "Orientation:"
      set label(skelplot,orient,normal) "Normal"
      set label(skelplot,orient,reverse) "Reverse"

      set label(skelplot,view,title) "View:"
      set label(skelplot,view,skelonly) "Skeleton Plot only"
      set label(skelplot,view,both) "Both plot and graph"

      set label(skelplot,random,title) "Create Random Sample"
      set label(skelplot,random,rings) "Rings:"
      set label(skelplot,random,name) "Sample Name:"

      set label(skelplot,color,title) "New Line Color:"

      # Buttons
      set label(skelplot,buttons,attribs) "Attributes"
      set label(skelplot,buttons,options) "Options"
      set label(skelplot,buttons,update) "Update All"
      set label(skelplot,buttons,redo) "Redo Plot"
      set label(skelplot,buttons,close) "Close"
      set label(skelplot,buttons,ok) "OK"
      set label(skelplot,buttons,cancel) "Cancel"
      set label(skelplot,buttons,resize) "Resize Graph"
      set label(skelplot,buttons,apply) "Apply"

      # Attributes Window
      set label(skelplot,attribs,title) "Attributes"
      set label(skelplot,attribs,width) "Width:"
      set label(skelplot,attribs,year) "Year:"
      set label(skelplot,attribs,length) "Bone Length:"
      set label(skelplot,attribs,type) "Type:"
      set label(skelplot,attribs,color) "Color:"
      set label(skelplot,attribs,text) "Text Note:"
      set label(skelplot,attribs,notes) "Notes:"


      # Titles
      set label(skelplot,titles,cross) "Skeleton Plot Cross-Dating"
      set label(skelplot,titles,exit) "Exit"

      # Messages
      set label(skelplot,message,exit) "Do you really want to exit program?"
      set label(skelplot,message,exityes) "Exit"
      set label(skelplot,message,exitno) "Don't Exit"
    }
}



proc language_update_attributes {labelvar language} {
    upvar #0 $labelvar label

    if {$language == "english"} then {
        # Attributes Window
        set label(attribs,title) "Attributes"
        set label(attribs,width) "Width:"
        set label(attribs,year) "Year:"
        set label(attribs,length) "Bone Length:"
        set label(attribs,type) "Type:"
        set label(attribs,color) "Color:"
        set label(attribs,text) "Text Note:"
        set label(attribs,notes) "Notes:"
    }
}
