proc trees_measure_ringwidths {} {
    global session mosaic findrings measurements
    global needSave noprompting labels
    global gaugevar
    
    set gaugenum 0


    if {$findrings(status) != "COMPLETE"} {
        messagebox "Measurements Error" "Cannot measure widths because findrings is not complete."
        set measurements(status) NONE
    } elseif {$measurements(status) == "COMPLETE"} {
        messagebox "Measurements Info" "Tree rings have already been measured."
    } else {

        set gaugenum [gauge_gui_add "Measure Ring Widths"]

        set measurements(status) "ACTIVE"
        trees_update_status

        if {![info exists mosaic(loaded,mosaic)]} {
            set mosaic(loaded,mosaic) [Sadie_TREES_ByteOpen $session(directory)/images/mosaic/$mosaic(file,mosaic)]
        }
        if {![info exists mosaic(loaded,index)]} {
            set mosaic(loaded,index) [Sadie_TREES_MosaicIndexOpen $session(directory)/images/mosaic/$mosaic(file,index)]
        }

        if {$gaugenum != 0} {gauge_gui_update $gaugenum 10}

         set measurements(loaded) "true"

	 
	 if {![info exists findrings(loaded,chainmap)]} {
	     set findrings(loaded,chainmap) [Sadie_TREES_Disk2Chain $session(directory)/images/mosaic/$findrings(file,chainmap)]
	 }

	 global ringwidth profiles diff_profiles earlywidth latewidth boundbox
	 Sadie_TREES_Chain_RingWidths $session(directory) $mosaic(loaded,mosaic) $mosaic(loaded,index) $findrings(loaded,chainmap) "ringwidth" "profiles" "diff_profiles" "earlywidth" "latewidth" "boundbox"
	 
	 if {$gaugevar(cancel) != 0} {
	     if {$gaugenum != 0} {gauge_gui_delete $gaugenum}
	     set measurements(status) "NONE"
	     trees_update_status
	     return;
	 }
        if {$gaugenum != 0} {gauge_gui_update $gaugenum 60}


	set measurements(ringwidth) $ringwidth
	unset ringwidth

        global global_endyear
        set global_endyear [expr [llength $measurements(ringwidth)]-1]
        .trees_main.menubar.m.segmentation.menu entryconfigure $labels(menu,segmentation,preference) -state normal        

	set measurements(profiles) $profiles
        unset profiles

        set measurements(diff_profiles) $diff_profiles
        unset diff_profiles
        
        set measurements(earlywidth) $earlywidth
        unset earlywidth     
  
        set measurements(latewidth) $latewidth
        unset latewidth
        
        set measurements(boundbox) $boundbox
        unset boundbox
 
        Sadie_TREES_ByteClose $mosaic(loaded,mosaic)
        unset mosaic(loaded,mosaic)

        Sadie_TREES_MosaicIndexClose $mosaic(loaded,index)
        unset mosaic(loaded,index)

        puts "Done measuring ring widths..."

        if {$gaugenum != 0} {gauge_gui_update $gaugenum 90}

        set measurements(status) "COMPLETE"
        trees_update_status

    }

    if {$gaugenum != 0} {
        gauge_gui_delete $gaugenum
    }

    trees_update_status
	trees_autosave
    
	if {$measurements(status) == "COMPLETE"} {
        if {$noprompting != 1} {
            set answer [tk_dialog .dlg "Continuing Analysis Dialog" \
                     "The next step is skeleton plot generation.  Do you wish to continue?" \
                     question \
                     1 $labels(button,no) $labels(button,yes) ]
        } else {
            set answer 1
        }
        
        if {$answer == 1} {
            trees_skelplot_create
        }
    }
}
