#----------------------- TREES Menu Bar ------------------------------#

proc trees_create_menubar {win} {
    global labels lang balloonHelpActive
    global currentState skelplot
    global flag
    frame ${win} -relief raised -borderwidth 2 -bg LightGray
    pack ${win} -side top -fill x
    
    menubutton ${win}.file -bg LightGray -fg #B80000\
	    -textvariable labels(file,title) -menu ${win}.file.menu
    menu ${win}.file.menu -tearoff 0
    
    menubutton ${win}.edit -bg LightGray -fg #B80000\
	    -textvariable labels(edit,title) -menu ${win}.edit.menu
    menu ${win}.edit.menu -tearoff 0
    
    menubutton ${win}.skeletonplot -bg LightGray -fg #B80000\
	    -textvariable labels(skeletonplot,title) -menu ${win}.skeletonplot.menu
    menu ${win}.skeletonplot.menu -tearoff 0
    
    
    set labels(segmentation,title) "Segmentation"
    menubutton ${win}.segmentation -bg LightGray -fg #B80000\
	    -textvariable labels(segmentation,title) -menu ${win}.segmentation.menu
    menu ${win}.segmentation.menu -tearoff 0

    
    menubutton ${win}.options -bg LightGray -fg #B80000\
	    -textvariable labels(options,title) -menu ${win}.options.menu
    menu ${win}.options.menu -tearoff 0
    
    menubutton ${win}.stage -bg LightGray -fg #B80000\
	    -textvariable labels(stage,title) -menu ${win}.stage.menu
    menu ${win}.stage.menu -tearoff 0

    menubutton ${win}.help -bg LightGray -fg #B80000\
	    -textvariable labels(help,title) -menu ${win}.help.menu
    menu ${win}.help.menu -tearoff 0
    
    menubutton ${win}.debug -bg LightGray -fg #B80000\
	    -textvariable labels(menu,debug,title) -menu ${win}.debug.menu
    menu ${win}.debug.menu -tearoff 0
    
    #  Language Menu Disabled JE 7/6/99
    #   menubutton ${win}.lang -bg LightGray -fg #B80000\
	    #     -textvariable labels(lang,title) -menu ${win}.lang.menu
    #   menu ${win}.lang.menu
    
    
    pack ${win}.file ${win}.edit ${win}.skeletonplot ${win}.segmentation ${win}.stage ${win}.options -side left
    pack ${win}.help ${win}.debug -side right
    
    
    # File Menu
    ${win}.file.menu add command -label $labels(menu,file,new) -background LightGray -foreground #0000C8\
	    -command [subst -nocommands { 
        if {[trees_close_session] == "ok"} then {           
	    trees_create_new_session
        }       
    }]
    ${win}.file.menu add command -label $labels(menu,file,open) -background LightGray -foreground #0000C8\
	    -command [subst -nocommands { 
	if {[trees_close_session] == "ok"} then {           
	    trees_load_datafile
	}       
    }]
	
	${win}.file.menu add separator -background LightGray
	
	${win}.file.menu add command -label $labels(menu,file,close) -state disabled -background LightGray -foreground #0000C8\
		    -command {
		trees_close_session
	    }
       
   ${win}.file.menu add separator -background LightGray 

   ${win}.file.menu add command -label $labels(menu,file,save) -state disabled -background LightGray -foreground #0000C8\
     -command {
           trees_session_save
       }
   ${win}.file.menu add command -label $labels(menu,file,saveas) -state disabled -background LightGray -foreground #0000C8\
     -command {
           trees_session_saveas
       }

   ${win}.file.menu add separator -background LightGray 

   ${win}.file.menu add command -label $labels(menu,file,csv) -state disabled -background LightGray -foreground #0000C8\
     -command {
           trees_export_data
       }

   ${win}.file.menu add command -label $labels(menu,file,widthrwl) -state disabled -background LightGray -foreground #0000C8\
     -command {
         trees_export_variable ringwidth
       }

   ${win}.file.menu add command -label $labels(menu,file,laterwl) -state disabled -background LightGray -foreground #0000C8\
     -command {
         trees_export_variable latewidth
       }

   ${win}.file.menu add command -label $labels(menu,file,earlyrwl) -state disabled -background LightGray -foreground #0000C8\
     -command {
         trees_export_variable earlywidth
       }

   ${win}.file.menu add separator -background LightGray 

   ${win}.file.menu add command -label $labels(menu,file,exit) -background LightGray -foreground #0000C8\
     -command [subst -nocommands { 
            handle_close .trees
       }]


   # Edit Menu
   ${win}.edit.menu add command -label $labels(menu,edit,modifysession) -background LightGray -foreground #0000C8\
     -command {
               if {![winfo exists .modsession]} {
                  trees_modify_session
               }
              }
   ${win}.edit.menu add command -label $labels(menu,edit,modseriesname) -background LightGray -foreground #0000C8\
     -command {
               trees_modify_samplename
              }


   # Skeleton Plot Menu
   
   ${win}.skeletonplot.menu add command -label $labels(menu,skeletonplot,attributes) -background LightGray -foreground #0000C8\
     -command {
               if {![winfo exists .trees_main.attributes]} {
                  display_attributes_dialog .trees_main.attributes
               } 
              }   
   
   ${win}.skeletonplot.menu add cascade -label $labels(menu,skeletonplot,options) -background LightGray -foreground #0000C8 \
     -menu ${win}.skeletonplot.menu.options 
   
   menu ${win}.skeletonplot.menu.options -tearoff 0

   ${win}.skeletonplot.menu.options add command -label "Change Cutoffs" -background LightGray -foreground #0000C8\
     -command {
                 if {![winfo exists .trees_main.chgcutoff]} {
                    change_cutoff SkelPlot .trees_main.chgcutoff .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas
                 } 
              }   

   menu ${win}.skeletonplot.menu.options.chgdisp -tearoff 0

   ${win}.skeletonplot.menu.options add cascade -label "Display Options" -background LightGray -foreground #0000C8\
     -menu ${win}.skeletonplot.menu.options.chgdisp

   ${win}.skeletonplot.menu.options.chgdisp add radio -label "Timeseries and Skeleton Plot" -background LightGray -foreground #0000C8\
     -variable SkelPlot(sample,series,timeseries) -value 1 \
     -command { redraw_skelplot SkelPlot .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas }

   ${win}.skeletonplot.menu.options.chgdisp add radio -label "Skeleton Plot Only" -background LightGray -foreground #0000C8\
     -variable SkelPlot(sample,series,timeseries) -value 0 \
     -command { redraw_skelplot SkelPlot .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas }

   ${win}.skeletonplot.menu.options.chgdisp add radio -label "Timeseries Only" -background LightGray -foreground #0000C8\
     -variable SkelPlot(sample,series,timeseries) -value 2 \
     -command {  set seriesname "series"
                load_ringwidth_series SkelPlot $measurements(ringwidth) $seriesname
                redraw_skelplot SkelPlot .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas }

   ${win}.skeletonplot.menu.options.chgdisp add radio -label "earlywood Timeseries Only" -background LightGray -foreground #0000C8\
     -variable SkelPlot(sample,series,timeseries) -value 3 \
     -command {  set seriesname "series"
             
                load_ringwidth_series SkelPlot $measurements(earlywidth) $seriesname
               
                redraw_skelplot SkelPlot .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas }
   ${win}.skeletonplot.menu.options.chgdisp add radio -label "latewood Timeseries Only" -background LightGray -foreground #0000C8\
     -variable SkelPlot(sample,series,timeseries) -value 4 \
     -command {  set seriesname "series"
                load_ringwidth_series SkelPlot $measurements(latewidth) $seriesname
                redraw_skelplot SkelPlot .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas }
 
 ${win}.skeletonplot.menu.options add cascade -label "Change Scale" -background LightGray -foreground #0000C8\
     -menu ${win}.skeletonplot.menu.options.chgscale    
     
   menu ${win}.skeletonplot.menu.options.chgscale -tearoff 0
   
   ${win}.skeletonplot.menu.options.chgscale add radio -label "Large" -background LightGray -foreground #0000C8\
     -variable SkelPlot(scale) -value 12 \
     -command { redraw_skelplot SkelPlot .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas }

   ${win}.skeletonplot.menu.options.chgscale add radio -label "Medium" -background LightGray -foreground #0000C8\
     -variable SkelPlot(scale) -value 10 \
     -command { redraw_skelplot SkelPlot .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas }

   ${win}.skeletonplot.menu.options.chgscale add radio -label "Small" -background LightGray -foreground #0000C8\
     -variable SkelPlot(scale) -value 8 \
     -command { redraw_skelplot SkelPlot .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas }
                                           
   ${win}.skeletonplot.menu add command -label $labels(menu,skeletonplot,select) -background LightGray -foreground #0000C8\
     -command { 
               if {![winfo exists .trees_main.select]} {
                  select_ring_number .trees_main.select .trees_main.skelplotpanel series topmarker bottommarker timeseries .trees_main.imagepanel.canvas
               }
              }  
                              
   ${win}.skeletonplot.menu add separator -background LightGray 
   
   ${win}.skeletonplot.menu add command -label $labels(menu,skeletonplot,addring) -background LightGray -foreground #0000C8\
     -command {
               add_ring SkelPlot Image .trees_main.add .trees_main.imagepanel.canvas .trees_main.zoompanel.zoomframe.canvas .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr  
              }   

   ${win}.skeletonplot.menu add command -label $labels(menu,skeletonplot,removering) -background LightGray -foreground #0000C8\
     -command {
              remove_ring SkelPlot Image .trees_main.remove .trees_main.imagepanel.canvas .trees_main.zoompanel.zoomframe.canvas .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr    
              }   

   ${win}.skeletonplot.menu add command -label $labels(menu,skeletonplot,startyear) -background LightGray -foreground #0000C8\
     -command {
               if {![winfo exists .trees_main.setstartyear]} {
                  trees_set_startyear SkelPlot Image .trees_main.setstartyear .trees_main.imagepanel.canvas .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr      
               }
              }  

   ${win}.skeletonplot.menu add command -label $labels(menu,skeletonplot,endyear) -background LightGray -foreground #0000C8\
     -command {
               if {![winfo exists .trees_main.setendyear]} {
                  trees_set_endyear SkelPlot Image .trees_main.setendyear .trees_main.imagepanel.canvas .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr      
               }
              }  

   ${win}.skeletonplot.menu add separator -background LightGray 
   
   ${win}.skeletonplot.menu add command -label $labels(menu,skeletonplot,redraw) -background LightGray -foreground #0000C8\
     -command {
              redraw_skelplot SkelPlot .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas
              }   

   ${win}.skeletonplot.menu add command -label $labels(menu,skeletonplot,invert) -background LightGray -foreground #0000C8\
     -command {
      if { $SkelPlot(sample,series,invert) == 0 } {
         set SkelPlot(sample,series,invert) 1
      } else {
         set SkelPlot(sample,series,invert) 0
      }
      redraw_skelplot SkelPlot .trees_main.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas                
      }                                                                                     

      # Stage Motion Menu
      ${win}.stage.menu add command -label $labels(menu,stage,link) -background LightGray -foreground #0000C8\
	      -command { trees_stagelink } 
      
 # Segmentation menu
  set labels(menu,segmentation,preference) "Segment Preference"
  set labels(menu,segmentation,Selectsegment) "Select Segment"
  set labels(menu,segmentation,Insertsegment) "Join Segment"
  set labels(menu,segmentation,Deletesegment) "Delete Segment" 
 
  ${win}.segmentation.menu add command -label $labels(menu,segmentation,preference) -background LightGray -foreground #0000C8\
     -command {
               if {![winfo exists .modsession]} {
                seg_preference_dialog
                  }
              }
   
  ${win}.segmentation.menu add command -label $labels(menu,segmentation,Selectsegment) -background LightGray -foreground #0000C8\
     -command {
               if {![winfo exists .modsession]} {
                set roi(selected) 0
	      segmentselect_dialog
                  }
              }
   ${win}.segmentation.menu add command -label $labels(menu,segmentation,Insertsegment) -background LightGray -foreground #0000C8\
     -command Insert_segment_dialog
              
   ${win}.segmentation.menu add command -label $labels(menu,segmentation,Deletesegment) -background LightGray -foreground #0000C8\
	   -command Delete_segment_dialog
  
 # Options
   ${win}.options.menu add check -label $labels(menu,options,noprompt) -background LightGray -foreground #0000C8\
      -variable noprompting -offvalue 0 -onvalue 1


   # Help
   ${win}.help.menu add check -label $labels(menu,help,balloon) -background LightGray  -foreground #0000C8\
      -variable balloonHelpActive
      
   ${win}.help.menu add separator -background LightGray 
   
   ${win}.help.menu add command -label $labels(menu,help,about) -background LightGray -foreground #0000C8\
     -command {
	    global labels lang
	    dialog_create "About TREES" .about
        label .about.info.lbl -text "TREES 0.0a0" -font lucidasans-18 -fg blue -bg LightGray
	    button .about.controls.ok -text "OK" -command { destroy .about } -fg black -bg LightGray
        image create photo treeslogo -file ${trees_dir}/trees.gif
        frame .about.info.treeslogo -width 200 -height 200 \
           -relief raised -borderwidth 3 
        
        canvas .about.info.treeslogo.canvas -width 200 -height 200
        .about.info.treeslogo.canvas create image 0 0 \
           -image treeslogo -tag treeslogo -anchor nw
        
        pack .about.info.treeslogo.canvas 
        pack .about.info.lbl -side top
        pack .about.info.treeslogo -side bottom
        pack .about.controls.ok -side bottom

     }


   # Debug
   ${win}.debug.menu add command -label $labels(menu,debug,sessionlog) -background LightGray -foreground #0000C8\
      -command {
                    if {[wm state .sessionlog] == "withdrawn"} {
                        wm deiconify .sessionlog
                        raise .sessionlog
                    } else {
                        wm withdraw .sessionlog
                    }
                }
      
   ${win}.debug.menu add separator -background LightGray 
   ${win}.debug.menu add command -label "Terminal" -background LightGray -foreground #0000C8\
      -command {   
                  exec rxvt &
               }   
   ${win}.debug.menu add command -label $labels(menu,debug,exitnow) -background LightGray -foreground #0000C8\
      -command {   
                  exit_now .
               }

#  Language Menu Disabled JE 7/6/99
   # Language   
#   ${win}.lang.menu add command -label "English" -background LightGray -foreground #0000C8\
#     -command [subst -nocommands { 
#         global lang
#         set lang english
#	 language_update labels $lang
#	 destroy $win
#	 trees_create_menubar $win
#       }]
      
       
}
      
#-----------------------------------------------------------#

# Exit Now
# Procedure called when "Exit Now" is called from the Debug -> Exit
# Now menu.  Terminates the application immediately.

proc exit_now { win } { 
   if { $win == "." } {
      destroy .
   }
}
