#ifndef TREES_CAMERADEVICE_H
#define TREES_CAMERADEVICE_H 1

extern "C" {
#include <libraw1394/raw1394.h>
#include <libdc1394/dc1394_control.h>
#include <sadie.h>
}

namespace std
{

  class Cameradevice {
    unsigned char* viewbuf;
    unsigned char* fullbuf;
    raw1394handle_t rawhandle;
    dc1394_cameracapture * dc;
    bool multibuffer;
    int* incr;
    unsigned int skipsize;
    unsigned int dsize;
    unsigned int hoff;
    unsigned int voff;
    unsigned int nbufs;
    unsigned int bpp;
    unsigned int horiz_size;
    unsigned int vert_size;
    unsigned int camdevprogres_type;
    void emitline(unsigned char* startaddr, unsigned char*& dst);
  public:
    Cameradevice(int unit, int picture_timeout, int numbufs,
                 unsigned int h, unsigned int v,
                 unsigned int dn, unsigned int dd);
    ~Cameradevice();
    unsigned int height() const { return vert_size; }
    unsigned int width()  const { return horiz_size; }
    unsigned int depth()  const { return bpp; }
    unsigned int size();
    bool progrescol()     const { return 0; }
    unsigned int snap_width()  const { return dc->frame_width - hoff; }
    unsigned int snap_height() const { return dc->frame_height - voff; }
    unsigned char* acquire();
    unsigned char* snapshot();
    bool resize(unsigned int h_req, unsigned int v_req);
    IMAGE* acquire_sadie(int,int,int,int);
    int enable_live(int);
    int set_gain(int);
  };

} // namespace std

#endif /* !TREES_CAMERADEVICE_H */
