#if HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */
#include <stdlib.h>
#include <sadie.h>
#include "chain.h"
#if WITH_DMALLOC
#include <dmalloc.h>
#endif /* WITH_DMALLOC */


void DISK2CHAIN (
char *filename,              /* Filename for reading chain code */
CHAIN **chainmap             /* Address of pointer to chain structure */
) {
    unsigned int *startCoord;
    unsigned char *code_valid;
    LIST_NODE *newLnode, **prevLnode;
    CHAIN_NODE *newCnode, **prevCnode;
    FILE *fp;

    fp = fopen(filename, "r");
    if (fp == NULL) {
        MESSAGE('E'," Can't open chain code file.");
	goto the_end;
    }

    /* Allocate memory for chain structure */
    (*chainmap) = (CHAIN *)malloc(sizeof(CHAIN));
    startCoord = (unsigned int *)calloc(2, sizeof(unsigned int));
    code_valid = (unsigned char *)calloc(2, sizeof(unsigned char));
    
    /* Read header from file */
    fread((char *)&((*chainmap)->nlin), CHAIN_HEADER_SIZE, 1, fp);
    (*chainmap)->list = NULL;
    prevLnode = (LIST_NODE **)&((*chainmap)->list);

    /* Read chain code from file into chain structure */
    while (fread(startCoord, sizeof(unsigned int), 2, fp) == 2) {
	newLnode = (LIST_NODE *)malloc(sizeof(LIST_NODE));
	newLnode->startj = startCoord[0];
	newLnode->startk = startCoord[1];
	fread((char *)&(newLnode->ring_type), sizeof(unsigned char), 1, fp);
	fread((char *)&(newLnode->ring_id), sizeof(int), 1, fp);
	newLnode->chain = NULL;
	newLnode->next = NULL;
	(*prevLnode) = newLnode;
	prevLnode = (LIST_NODE **)&(newLnode->next);
	prevCnode = (CHAIN_NODE **)&(newLnode->chain);
	fread(code_valid, sizeof(unsigned char), 2, fp);
	while (code_valid[0] != TERM_CODE) {
	    newCnode = (CHAIN_NODE *)malloc(sizeof(CHAIN_NODE));
	    newCnode->code = code_valid[0];
	    newCnode->valid = code_valid[1];
	    newCnode->next = NULL;
	    (*prevCnode) = newCnode;
	    prevCnode = (CHAIN_NODE **)&(newCnode->next);
	    fread(code_valid, sizeof(unsigned char), 2, fp);
	}
    }
    fclose(fp);
    
 the_end:
}





