/* Workarounds for missing ISO C99 math functions, etc.
 *
 * $Id: junkmath.h,v 1.2 2004/11/09 12:46:58 mmunro Exp $
 */

#ifndef JUNKMATH_H
#define JUNKMATH_H 1

#ifndef M_PI
#define M_PI  3.14159265358979323846  /* pi (to double precision) */
#endif /* ! defined(M_PI) */

#ifndef M_PI_2
#define M_PI_2  1.57079632679489661923  /* pi/2 (to double precision) */
#endif /* ! defined(M_PI_2) */

#if (!defined __USE_ISOC99 && !defined _ISOC99_SOURCE && \
     !defined _ISOC9X_SOURCE && !(defined __STDC_VERSION__ && \
                                  (__STDC_VERSION__ >= 199901L)))
/* Not using C99 source . . . */

static double fmax(double a, double b)
{
  return (a > b) ? a : b;
}

static double fmin(double a, double b)
{
  return (a < b) ? a : b;
}
/*
static long double atanl(long double t)
{
  return (long double)atan((double)t);
}

static long double atan2l(long double s, long double t)
{
  return (long double)atan2((double)s, (double)t);
}
*/
static double round(double x)
{
  double a, ip;

  a = modf (x, &ip);
  if (a <= (-0.5))
    return ip - 1;
  else if (a >= 0.5)
    return ip + 1;
  else
    return ip;
}
#endif /* Not using C99 source */

#endif /* !JUNKMATH_H */
