/** @file trees_widthvec.c
 * Handling measurements (ring widths and other such data)
 * within TREES.
 * 
 * @author University of Arizona Digital Image Analysis Lab
 * @date 2004
 * @version $Id: trees_widthvec.c,v 1.1 2004/07/17 22:44:44 mmunro Exp $
 */

/* This file is part of TREES.

   TREES is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   TREES is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with TREES; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.  */

#if HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */
#include "trees_widthvec.h"
#include <unistd.h>

void
widthvec_destruct (void *data)
{
  widthvecp_t victim;
 
 if (data != NULL)
    {
      victim = (widthvecp_t) data;
      free (victim->val);
      free (victim);
    }
}
