#ifdef __cplusplus
extern "C" {
#endif 

#ifndef SADIEPROTO_H
#define SADIEPROTO_H

#include <sadie.h>
#include <sys/time.h>

/* This data structure definition is required for ROI_TREERINGMAG */    
typedef struct {
    uint32_t hstart;
    uint32_t hend;
    uint32_t *vstart;
    uint32_t *vend;
}                    LOCAL_INDEX;

extern void BINGRID (IMAGE*, IMAGE**);
extern void CANNY (IMAGE*, double, int, IMAGE**);
extern void CHAINCODE (IMAGE*, IMAGE**);
extern void CMPLBL8 (IMAGE*, IMAGE**);
extern void COLOR_OVERLAY (IMAGE*, IMAGE*, int, IMAGE**);
extern void CREATEGAUSS (int, double, IMAGE **);
extern int  CREATEMOSAIC (char**, int, int, int, int*, int*, PIXEL*, PIXEL*, PIXEL, IMAGE**);
extern void CREATELOG (int, double, IMAGE **);
extern void FINDBESTFOCUS (IMAGE**, int, int*);
extern void FINDCENTER (IMAGE*);
extern void FINDGAINADJ (IMAGE*, IMAGE*, int, int, PIXEL*, PIXEL*);
extern void FIND_REGISTER (IMAGE*, IMAGE*, int, int, int*, int*, PIXEL*, PIXEL*);
extern void FIND_REGISTER_ROUGH (IMAGE*, IMAGE*, int, int, int, int, int, int*, int*);
extern void FOURIERDESC (IMAGE*);
extern int  GAINADJMOS (IMAGE**, int, int, int, int*, int*, PIXEL*, PIXEL*, PIXEL, IMAGE**);
extern void HOUGH (IMAGE*, int, int, int, IMAGE**, IMAGE**);
extern void IMG2ASCII (IMAGE*);
extern void IMGCOPY (IMAGE*, IMAGE**);
extern void ISOLATE (IMAGE*, double, IMAGE**);
extern void LINK_DOUBLETHRESH (IMAGE*, IMAGE*, int, IMAGE**, IMAGE**);
extern void LINK_TREERINGS (IMAGE*, int, IMAGE**, IMAGE**);
extern void MAXGRADDIR (IMAGE*, IMAGE*);
extern void NONMAXSUPRX (IMAGE*, IMAGE**);
extern void PERIODOGRAM (IMAGE*, IMAGE**);
extern void RADIALAVG (IMAGE*);
extern void REGISTER (IMAGE*, IMAGE*, int, int, IMAGE**, IMAGE**, IMAGE**, IMAGE**);
extern void RINGWIDTHS (IMAGE*, IMAGE*, IMAGE*, IMAGE**);
extern void RINGWIDTHS_NOCHECK (IMAGE*, IMAGE*, IMAGE*, IMAGE**);
extern void SECTOR (IMAGE *, IMAGE **);
extern void SECTOR8 (IMAGE *, IMAGE **);
extern void SIZEFILTER (IMAGE*, int, IMAGE**);
extern void TREERINGMAG (IMAGE*, double, int, IMAGE**);

extern void SETMEAN (IMAGE*, PIXEL, IMAGE**);

extern int  calcsector (PIXEL);
extern long delay (struct timeval, struct timeval);
extern void quicksort (int*, int, int);
extern void quicksort2 (int*, int, int);

extern void ROI_SCONVL (IMAGE *, LOCAL_INDEX *, PIXEL *, short, short, IMAGE **);
extern void ROI_GRADIENT (IMAGE *, LOCAL_INDEX *, PIXEL *, PIXEL *, short, IMAGE **, IMAGE **);
extern void ROI_TREERINGMAG (IMAGE  *, LOCAL_INDEX *, double, int, IMAGE  **);

#endif



#ifdef __cplusplus
}
#endif
