/*
##########################################
# Sadie_General.c -
#   Set of routines for linking misc. SADIE routines to tcl/tk.
#
# RCS: $Id: Sadie_General.c,v 1.3 2004/09/04 01:13:44 vishwask Exp $ 
# 
# Digital Image Analysis Lab
# Dept. of Electrical and Computer Engineering
# University of Arizona
##########################################
*/

#if HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */
#include <tcl.h>
#include <tk.h>
#include <sadie.h>


/* RCS Indentification information */
static char rcsid[] = "$Id: Sadie_General.c,v 1.3 2004/09/04 01:13:44 vishwask Exp $";



int Sadie_General_CloseCmd(ClientData client_data, Tcl_Interp* interp, int argc, char *argv[])
{
  int imgaddr;
  IMAGE *theimg;
  char   msg[SLEN];

  if( argc <= 1 ) {
    sprintf(msg, "Usage: Sadie_General_Close image_address");
    Tcl_SetResult(interp, msg, TCL_VOLATILE);
    return TCL_ERROR;
  }

  sscanf(argv[1], "%x", &imgaddr);
  theimg = (IMAGE *) imgaddr;


  RELIMG(&theimg);
  
  return TCL_OK;
}


int Sadie_General_InitializeProgCmd(ClientData client_data, Tcl_Interp* interp, int argc, char *argv[])
{
  INIT();
  
  return TCL_OK;
}



/*************************************************************************
 *
 * This procedure initializes the the Sadie_General procedures when
 * this package is loaded.
 *
 *************************************************************************/
int Sadie_General_Init(Tcl_Interp *interp) {
  Tcl_CreateCommand(interp, "Sadie_General_Close", Sadie_General_CloseCmd, 
  	(ClientData) NULL, NULL);
  Tcl_CreateCommand(interp, "Sadie_General_InitializeProg", Sadie_General_InitializeProgCmd, 
  	(ClientData) NULL, NULL);
    
  return TCL_OK;
}

